Issue 92797 - Mechanism for MOOXML import to support indices of external documents in address references.
Summary: Mechanism for MOOXML import to support indices of external documents in addre...
Status: CLOSED FIXED
Alias: None
Product: Calc
Classification: Application
Component: open-import (show other issues)
Version: recent-trunk
Hardware: All All
: P3 Trivial (vote)
Target Milestone: ---
Assignee: oc
QA Contact: issues@sc
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2008-08-14 12:03 UTC by ooo
Modified: 2013-08-07 15:14 UTC (History)
3 users (show)

See Also:
Issue Type: FEATURE
Latest Confirmation in: ---
Developer Difficulty: ---


Attachments

Note You need to log in before you can comment on or make changes to this issue.
Description ooo 2008-08-14 12:03:01 UTC
Implement mechanism for MOOXML import to support indices of external documents
in address references.
Comment 1 ooo 2008-08-14 12:05:45 UTC
Started in CWS 'mooxlsc'.
Comment 2 daniel.rentz 2008-08-14 13:09:04 UTC
DR->ER: Also needed: DDE links. They are stored as follows:

in Excel UI:
=server|'topic'!'item'

e.g.
=excel|'X:\PATH\[FILE.XLSX]Sheet1'!'R1C1'
to refer to cell Sheet1.A1 in the file X:\PATH\FILE.XLSX

or:
=soffice|'file:///X:/PATH/FILE.ODS'!'Sheet1.A1'
to refer to cell Sheet1.A1 in the file X:\PATH\FILE.ODS

in MSOOXML format, these formulas are stored as following:
=[link-index]'item'

e.g.:
=[1]'R1C1'
=[2]'Sheet1.A1'

where [1] is an external link with DDE service name "excel" and topic
"X:\PATH\[FILE.XLSX]Sheet1", and [2] contains service "soffice" and topic
"file:///X:/PATH/FILE.ODS".

The parser has to generate the formula =DDE("service";"topic";"item" from that data.

Furthermore, MSOOXML allows to create OLE links to external cells, e.g. in Excel UI:
=progid|target!item

e.g.
=Excel.Sheet.12|'X:/PATH/FILE.XLSX'!'!Sheet1!R1C1'

but that is not supported by Calc.



I suggest to handle external links and DDE with the same API, but this requires
something different than a simple sequence<string>, e.g. a
sequence<com.sun.star.sheet.ExternalLinkInfo> containing a link type
(external/DDE) and the related string data.
Comment 3 daniel.rentz 2008-08-14 13:29:27 UTC
here is a test document containing all kinds of internal and external links:
http://sc.openoffice.org/testdocs/external/externallink_import_oox7.xlsx

the same document in BIFF12 format is imported correctly already and can be used
as as reference:
http://sc.openoffice.org/testdocs/external/externallink_import_oox7.xlsb
Comment 4 ooo 2008-12-04 19:31:55 UTC
Note: External references are implemented. External named references are
implemented in the core code, but not imported by the filter. Conversion from
external syntax to DDE() function not implemented yet.

Handling of external references has completely been reworked. During runtime
they don't appear as hidden sheets anymore, thus don't occupy precious slots of
the 255 available sheets. Also only the used (referred) cells are imported and
stored with the document, which may significantly decrease storage footprint. As
before, they are stored as external tables, preserving backward compatibility.
Comment 5 ooo 2008-12-09 12:23:14 UTC
Reassigning to QA for verification.
Comment 6 oc 2008-12-11 15:18:42 UTC
verified in internal build cws_mooxlsc
Comment 7 thorsten.ziehm 2010-02-22 14:48:46 UTC
This issue is closed automatically. It should be fixed in a version with is
available for longer than half a year (OOo 3.1). If you think this issue isn't
fixed in the current version (OOo 3.2) please reopen it. But then please pay
attention about the field 'target milestone'.
The closure was approved by the Release Status Meeting at 22nd of February 2010
and it is based on the issue handling guideline for fixed/verified issues  :
http://wiki.services.openoffice.org/wiki/Handle_fixed_verified_issues